using System;
using System.Collections.Generic;
using BuecherwurmAPI.Models;
using Microsoft.Data.Sqlite;
using Microsoft.VisualBasic.CompilerServices;

namespace BuecherwurmAPI.Models
{
    internal class Katalog : IBookRepo
    {
        private SqliteConnection _dbConnection;

        public Katalog()
        {
            var connectionBuilder = new SqliteConnectionStringBuilder {DataSource = "LongWormMemory.db"};
            _dbConnection = new SqliteConnection(connectionBuilder.ConnectionString);
            _dbConnection.Open();
        }

        public IEnumerable<Book> GetAllBooks()
        {
            var books= new List<Book>();

            using (var command = _dbConnection.CreateCommand())
            {
                command.CommandText = @"SELECT * FROM Books";
                var dataReader = command.ExecuteReader();
                
                while (dataReader.Read())
                {             
                    books.Add(new Book
                    {
                        Name = (string) dataReader["Books"],
                        Author = (string) dataReader["Author"],
                        Country = (string) dataReader["Country"],
                        Link = (string) dataReader["Link"],
                        Language = (string) dataReader["Language"],
                        Pages = (long) dataReader["Pages"],
                        Year = (long) dataReader["Year"],
                        ProductId = (long) dataReader["ProductId"],
                        Category = (CategoryEnum) dataReader["Category"],
                        ImageLink = (string) dataReader["ImageLink"],
                        LendTime = (long) dataReader["LendTime"],
                        LendType = (LendTypeEnum) dataReader["LendType"]
                    });
                }
            }
            return books;
        }

        public Book GetBookById(long id)
        {
            using (var command = _dbConnection.CreateCommand())
            {
                command.Parameters.Add(new SqliteParameter("@id", SqliteType.Integer)).Value = id;
                command.CommandText = @"SELECT * FROM Books WHERE ProductId = @id";
                var dataReader = command.ExecuteReader();

                    var book = new Book
                    {
                        Name = (string) dataReader["Books"],
                        Author = (string) dataReader["Author"],
                        Country = (string) dataReader["Country"],
                        Link = (string) dataReader["Link"],
                        Language = (string) dataReader["Language"],
                        Pages = (long) dataReader["Pages"],
                        Year = (long) dataReader["Year"],
                        ProductId = (long) dataReader["ProductId"],
                        Category = (CategoryEnum) dataReader["Category"],
                        ImageLink = (string) dataReader["ImageLink"],
                        LendTime = (long) dataReader["LendTime"],
                        LendType = (LendTypeEnum) dataReader["LendType"]
                    };
                    return book;
            }
        }
        public void DeleteBook(Book book)
        {

        }

        public void AddBook (Book book)
        {

        }

        public void EditBook (Book book)
        {

        }

    }
}